'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Tabbordion = exports.Panel = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var tabbordionUuid = function () {
    var index = 0;

    return function () {
        return 'tabbordion-' + index++;
    };
}();

var isFunction = function () {
    function typeOfFn(fn) {
        return typeof fn === 'function';
    }

    function objectFn(fn) {
        return Object.prototype.toString.call(fn) === '[object Function]';
    }

    // typeof is fastest way to check if a function but older IEs don't support it for that and Chrome had a bug
    if (typeof typeOfFn === 'function' && typeof /./ !== 'function') {
        return typeOfFn;
    }

    return objectFn;
}();

function classWithModifiers(className, modifiers, separator) {
    var classNames = '';

    if (className == null) {
        return null;
    }

    if (typeof className !== 'string') {
        className = String(className);
    }

    if (!Array.isArray(modifiers)) {
        return className;
    }

    if (typeof separator !== 'string') {
        separator = '--';
    }

    var i = className.indexOf(' ');

    if (i >= 0) {
        classNames = className.slice(i);
        className = className.slice(0, i);

        if (separator.length > 0) {
            var prefixedClassName = ' ' + className + separator;
            var prefixedSeparator = ' ' + separator;

            for (i = classNames.indexOf(prefixedSeparator); i >= 0; i = classNames.indexOf(prefixedSeparator, i + className.length)) {
                classNames = classNames.replace(prefixedSeparator, prefixedClassName);
            }
        }
    }

    var BEM = className;

    for (i = 0; i < modifiers.length; i++) {
        if (typeof modifiers[i] === 'string' && modifiers[i].length > 0) {
            BEM += ' ' + className + separator + modifiers[i];
        }
    }

    return BEM + classNames;
}

function getElementHeight(element) {
    var bounds = element.getBoundingClientRect();
    var elementHeightInPixels = Math.ceil(bounds.bottom - bounds.top);

    return elementHeightInPixels;
}

// backwards compatibility export

var Panel = exports.Panel = function (_React$Component) {
    _inherits(Panel, _React$Component);

    function Panel(props) {
        _classCallCheck(this, Panel);

        var _this = _possibleConstructorReturn(this, (Panel.__proto__ || Object.getPrototypeOf(Panel)).call(this, props));

        _this.state = {
            contentHeight: null
        };

        _this.tag = props.tag || 'li';

        _this.handleInputChange = _this.handleInputChange.bind(_this);
        _this.handleLabelClick = _this.handleLabelClick.bind(_this);
        _this.updateHeight = _this.updateHeight.bind(_this);
        return _this;
    }

    _createClass(Panel, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.updateHeight();

            if (window.addEventListener) {
                window.addEventListener('resize', this.updateHeight, false);
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this.updateHeight();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.tag = nextProps.tag || 'li';
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (window.removeEventListener) {
                window.removeEventListener('resize', this.updateHeight, false);
            }
        }
    }, {
        key: 'updateHeight',
        value: function updateHeight() {
            if (this.props.animateContent && this.refs.content) {
                var animator = _reactDom2.default.findDOMNode(this.refs.animator);
                var content = _reactDom2.default.findDOMNode(this.refs.content);
                var height = null;

                switch (this.props.animateContent) {
                    case 'height':
                        height = this.props.checked ? getElementHeight(content) : 0;

                        var cssHeight = height + 'px';

                        if (animator.style.height === cssHeight) {
                            return;
                        }

                        animator.style.height = cssHeight;

                        if (content.style.marginTop) {
                            content.style.marginTop = null;
                        }

                        break;
                    case 'marginTop':
                        height = !this.props.checked ? getElementHeight(content) : 0;

                        // required for transitions: display: none; in parent will result any child to have zero height
                        // (yes, even before the display rule visually kicks in we will get zero for any child it has)
                        if (this.props.checked === false && height === 0) {
                            return;
                        }

                        var marginTop = -height + 'px';

                        if (content.style.marginTop === marginTop) {
                            return;
                        }

                        content.style.marginTop = marginTop;

                        if (animator.style.height) {
                            animator.style.height = null;
                        }

                        break;
                    default:
                }

                // would infinite loop if used setState
                if (this.state.height !== height) {
                    this.state.height = height;
                }
            }
        }
    }, {
        key: 'handleInputChange',
        value: function handleInputChange() {
            this.props.setIndex(this.props.index);
        }
    }, {
        key: 'handleLabelClick',
        value: function handleLabelClick(event) {
            event.preventDefault();
            var input = _reactDom2.default.findDOMNode(this.refs.input);
            if (input) input.click();
        }
    }, {
        key: 'render',
        value: function render() {
            var ariaSelected = this.props.checked ? 'true' : 'false';

            var elementProps = {
                'aria-expanded': this.props.children ? ariaSelected : null,
                'aria-selected': ariaSelected,
                'role': 'tab'
            };

            for (var key in this.props) {
                if (this.props.hasOwnProperty(key) && !Panel.propTypes.hasOwnProperty(key)) {
                    elementProps[key] = this.props[key];
                }
            }

            if (!this.props.visible) {
                elementProps.style = elementProps.style || {};
                elementProps.style.display = 'none';
            }

            var classNames = this.props.classNames;
            var separator = this.props.classSeparator;
            var id = this.props.name + '-' + this.props.index;
            var value = '' + this.props.index;

            var classModifiers = this.props.classModifiers;
            var modifiers = [];

            if (this.props.animateContent) {
                modifiers.push(classModifiers.animated);
            }

            modifiers.push(this.props.checked ? classModifiers.checked : classModifiers.unchecked);
            modifiers.push(this.props.disabled ? classModifiers.disabled : classModifiers.enabled);

            if (this.props.visible) {
                if (this.props.isBetween) {
                    modifiers.push(classModifiers.visibleBetween);
                } else {
                    if (this.props.isFirst) {
                        modifiers.push(classModifiers.visibleFirst);
                    }

                    if (this.props.isLast) {
                        modifiers.push(classModifiers.visibleLast);
                    }
                }
            }

            if (_react2.default.Children.count(this.props.children)) {
                var animatedModifiers = modifiers.concat(this.props.animateContent);

                var contentProps = {
                    'aria-labelledby': id,
                    'className': classWithModifiers(classNames.content, animatedModifiers, separator),
                    'id': 'panel-' + id,
                    'ref': 'content',
                    'role': 'tabpanel',
                    'style': { marginTop: '' }
                };

                var animatorProps = {
                    className: classWithModifiers(classNames.animator, animatedModifiers, separator),
                    ref: 'animator',
                    style: { height: '', overflow: 'hidden' }
                };

                switch (this.props.animateContent && this.state.contentHeight != null) {
                    case 'height':
                        animatorProps.style.height = this.state.contentHeight + 'px';
                        break;
                    case 'marginTop':
                        contentProps.style.marginTop = -this.state.contentHeight + 'px';
                        break;
                    default:
                }

                var children = _react2.default.createElement(this.props.contentTag || 'div', contentProps, function (props) {
                    return _react2.default.Children.map(props.children, function (child) {
                        if (child && child.type && child.type.isPanelChild === true) {
                            return _react2.default.cloneElement(child, {
                                isPanelChecked: props.checked,
                                isPanelVisible: props.visible,
                                panelIndex: props.index,
                                panelName: props.name,
                                panelSelectedChecked: props.selectedChecked,
                                panelSelectedIndex: props.selectedIndex,
                                setPanelIndex: props.setIndex
                            });
                        }

                        return child;
                    });
                }(this.props));

                if (this.props.animateContent) {
                    children = _react2.default.createElement('div', animatorProps, children);
                }

                modifiers.push(classModifiers.content);
            } else {
                modifiers.push(classModifiers.noContent);
            }

            elementProps.className = classWithModifiers(classNames.panel + (elementProps.className ? ' ' + elementProps.className : ''), modifiers, separator);

            return _react2.default.createElement(
                this.tag,
                elementProps,
                _react2.default.createElement('input', {
                    'aria-controls': children ? 'panel-' + id : null,
                    checked: this.props.checked,
                    className: classWithModifiers(classNames.state, modifiers, separator),
                    'data-state': 'tabbordion',
                    disabled: !this.props.visible || this.props.disabled,
                    id: id,
                    name: this.props.name,
                    onChange: this.handleInputChange,
                    ref: 'input',
                    type: this.props.type,
                    value: value
                }),
                _react2.default.createElement(
                    'label',
                    {
                        className: classWithModifiers(classNames.title, modifiers, separator),
                        id: 'label-' + id,
                        htmlFor: id,
                        onClick: this.handleLabelClick
                    },
                    this.props.title
                ),
                children
            );
        }
    }]);

    return Panel;
}(_react2.default.Component);

Panel.defaultProps = {
    animateContent: false,
    classModifiers: {
        animated: 'animated',
        checked: 'checked',
        content: 'content',
        disabled: 'disabled',
        enabled: 'enabled',
        noContent: 'no-content',
        unchecked: 'unchecked',
        visibleBetween: 'between',
        visibleFirst: 'first',
        visibleLast: 'last'
    },
    classNames: {
        animator: 'panel__animator',
        content: 'panel__content',
        panel: 'panel',
        state: 'panel__state',
        title: 'panel__title'
    },
    classSeparator: '--',
    disabled: false,
    visible: true
};

Panel.propTypes = {
    animateContent: _propTypes2.default.oneOf([false, 'height', 'marginTop']),
    checked: _propTypes2.default.bool,
    children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]),
    classModifiers: _propTypes2.default.shape({
        animated: _propTypes2.default.string,
        checked: _propTypes2.default.string,
        content: _propTypes2.default.string,
        disabled: _propTypes2.default.string,
        enabled: _propTypes2.default.string,
        noContent: _propTypes2.default.string,
        unchecked: _propTypes2.default.string,
        visibleBetween: _propTypes2.default.string,
        visibleFirst: _propTypes2.default.string,
        visibleLast: _propTypes2.default.string
    }),
    classNames: _propTypes2.default.shape({
        animator: _propTypes2.default.string,
        content: _propTypes2.default.string,
        panel: _propTypes2.default.string,
        state: _propTypes2.default.string,
        title: _propTypes2.default.string
    }),
    classSeparator: _propTypes2.default.string,
    contentTag: _propTypes2.default.string,
    disabled: _propTypes2.default.bool,
    index: _propTypes2.default.number,
    isBetween: _propTypes2.default.bool,
    isFirst: _propTypes2.default.bool,
    isLast: _propTypes2.default.bool,
    name: _propTypes2.default.string,
    selectedChecked: _propTypes2.default.array,
    selectedIndex: _propTypes2.default.number,
    setIndex: _propTypes2.default.func,
    tag: _propTypes2.default.string,
    title: _propTypes2.default.node.isRequired,
    type: _propTypes2.default.oneOf(['checkbox', 'radio']),
    visible: _propTypes2.default.bool
};

function getNextState(props, name, checked) {
    var count = 0;
    var index = null;
    var visibleCount = 0;

    _react2.default.Children.forEach(props.children, function (child) {
        if (child && child.type === Panel) {
            var childProps = child.props || child._store.props || {};

            if (typeof childProps.checked === 'boolean') {
                checked[count] = childProps.checked;
                if (index === null && checked[count]) {
                    index = count;
                }
            }

            if (childProps.visible) {
                visibleCount++;
            }

            count++;
        }
    });

    checked.length = count;

    for (var i = 0; i < count; i++) {
        if (typeof checked[i] !== 'boolean') {
            checked[i] = !!checked[i];
        }
        if (index === null && checked[i]) {
            index = i;
        }
    }

    return { checked: checked, count: count, index: index, name: name, visibleCount: visibleCount };
}

// backwards compatibility export

var Tabbordion = exports.Tabbordion = function (_React$Component2) {
    _inherits(Tabbordion, _React$Component2);

    function Tabbordion(props) {
        _classCallCheck(this, Tabbordion);

        // this, my friend, is a hack (getNextState needs further thoughts; render can prevent state change)
        var _this2 = _possibleConstructorReturn(this, (Tabbordion.__proto__ || Object.getPrototypeOf(Tabbordion)).call(this, props));

        _this2.stateLocked = false;

        _this2.state = getNextState(props, tabbordionUuid(), []);

        var index = props.initialIndex === ~~props.initialIndex ? props.initialIndex : null;
        // handle initial index
        if (_this2.state.index === null && index !== null && index >= 0 && index < _this2.state.count) {
            _this2.state.checked[index] = true;
            _this2.state.index = index;
        }

        _this2.setIndex = _this2.setIndex.bind(_this2);
        return _this2;
    }

    _createClass(Tabbordion, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!this.stateLocked) {
                this.setState(getNextState(nextProps, this.state.name, this.state.checked));
            }
        }
    }, {
        key: 'setIndex',
        value: function setIndex(newIndex) {
            var _this3 = this;

            var newState = { checked: this.state.checked, index: this.state.index };

            this.stateLocked = true;

            switch (this.props.mode) {
                // any panel can be open or closed (plausible accordion behavior)
                case 'multiple':
                    newState.index = newIndex;
                    newState.checked[newIndex] = !newState.checked[newIndex];
                    break;
                // one panel is always open (normal tabs behavior)
                case 'single':
                    newState.index = newIndex;
                    newState.checked = newState.checked.map(function (checked, index) {
                        return index === newIndex;
                    });
                    break;
                // only one panel may be open at one time (normal accordion behavior)
                case 'toggle':
                    newState.index = newState.index !== newIndex ? newIndex : null;
                    newState.checked = newState.checked.map(function (checked, index) {
                        return index === newIndex && newIndex === newState.index;
                    });
                    break;
                default:
                    throw new Error('unknown mode: ' + this.props.mode);
            }

            if (isFunction(this.props.onBeforeChange)) {
                var stateOverride = this.props.onBeforeChange({ checked: newState.checked.slice(0), index: newState.index }, { checked: this.state.checked.slice(0), index: this.state.index });

                if ((typeof stateOverride === 'undefined' ? 'undefined' : _typeof(stateOverride)) === 'object' && Array.isArray(stateOverride.checked) && stateOverride.checked.length === newState.checked.length && stateOverride.hasOwnProperty('index')) {
                    newState = {
                        checked: stateOverride.checked.map(Boolean),
                        index: stateOverride.index != null ? ~~stateOverride.index : null
                    };
                }
            }

            if (isFunction(this.props.onAfterChange)) {
                this.setState(newState, function () {
                    _this3.props.onAfterChange({ checked: newState.checked.slice(0), index: newState.index });
                    _this3.stateLocked = false;
                });
            } else {
                this.setState(newState, function () {
                    _this3.stateLocked = false;
                });
            }

            if (isFunction(this.props.onChange)) {
                this.props.onChange({ checked: newState.checked.slice(0), index: newState.index });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var elementProps = { role: 'tablist' };

            for (var key in this.props) {
                if (this.props.hasOwnProperty(key) && !Tabbordion.propTypes.hasOwnProperty(key)) {
                    elementProps[key] = this.props[key];
                }
            }

            if (elementProps.className) {
                elementProps.className = classWithModifiers(elementProps.className, ['checked-count-' + this.state.checked.reduce(function (count, checked) {
                    return count + checked;
                }, 0), 'count-' + this.state.count], this.props.classSeparator);
            }

            return _react2.default.createElement(
                this.props.tag,
                elementProps,
                function (props, state, setIndex) {
                    var modeType = props.mode === 'multiple' ? 'checkbox' : 'radio';
                    var name = props.name.length ? props.name : state.name;

                    var panelCounter = 0;
                    var visibleCounter = 0;

                    return _react2.default.Children.map(props.children, function (child) {
                        var isBetween = false,
                            isFirst = false,
                            isLast = false;

                        if (!child) {
                            return child;
                        } else if (child.type === Panel) {
                            var childProps = child.props || child._store.props || {};
                            var index = panelCounter++;

                            if (childProps.visible) {
                                visibleCounter++;

                                if (visibleCounter === 1) {
                                    isFirst = true;
                                }

                                if (visibleCounter === state.visibleCount) {
                                    isLast = true;
                                }

                                isBetween = !isFirst && !isLast;
                            }

                            child = _react2.default.cloneElement(child, {
                                animateContent: props.animateContent,
                                checked: state.checked[index],
                                classModifiers: props.classModifiers,
                                classNames: props.classNames,
                                classSeparator: props.classSeparator,
                                contentTag: childProps.contentTag || props.contentTag,
                                index: index,
                                isBetween: isBetween,
                                isFirst: isFirst,
                                isLast: isLast,
                                name: childProps.name || name,
                                selectedChecked: state.checked.slice(0),
                                selectedIndex: state.index,
                                setIndex: setIndex,
                                tag: childProps.tag || props.panelTag,
                                type: childProps.type || modeType
                            });
                        } else if (child.type && child.type.isPanel === true) {
                            child = _react2.default.cloneElement(child, {
                                panelName: name,
                                panelSelectedChecked: state.checked.slice(0),
                                panelSelectedIndex: state.index,
                                panelSetIndex: setIndex
                            });
                        }

                        return child;
                    });
                }(this.props, this.state, this.setIndex)
            );
        }
    }]);

    return Tabbordion;
}(_react2.default.Component);

Tabbordion.defaultProps = {
    animateContent: false,
    classModifiers: {
        animated: 'animated',
        checked: 'checked',
        content: 'content',
        disabled: 'disabled',
        enabled: 'enabled',
        noContent: 'no-content',
        unchecked: 'unchecked',
        visibleBetween: 'between',
        visibleFirst: 'first',
        visibleLast: 'last'
    },
    classNames: {
        animator: 'panel__animator',
        content: 'panel__content',
        panel: 'panel',
        state: 'panel__state',
        title: 'panel__title'
    },
    classSeparator: '--',
    initialIndex: null,
    mode: 'single',
    name: '',
    tag: 'ul'
};

Tabbordion.propTypes = {
    animateContent: _propTypes2.default.oneOf([false, 'height', 'marginTop']),
    classModifiers: _propTypes2.default.shape({
        animated: _propTypes2.default.string,
        checked: _propTypes2.default.string,
        content: _propTypes2.default.string,
        disabled: _propTypes2.default.string,
        enabled: _propTypes2.default.string,
        noContent: _propTypes2.default.string,
        unchecked: _propTypes2.default.string,
        visibleBetween: _propTypes2.default.string,
        visibleFirst: _propTypes2.default.string,
        visibleLast: _propTypes2.default.string
    }),
    classNames: _propTypes2.default.shape({
        animator: _propTypes2.default.string,
        content: _propTypes2.default.string,
        panel: _propTypes2.default.string,
        state: _propTypes2.default.string,
        title: _propTypes2.default.string
    }),
    classSeparator: _propTypes2.default.string,
    contentTag: _propTypes2.default.string,
    initialIndex: _propTypes2.default.number,
    mode: _propTypes2.default.oneOf(['multiple', 'single', 'toggle']),
    name: _propTypes2.default.string,
    onAfterChange: _propTypes2.default.func,
    onBeforeChange: _propTypes2.default.func,
    onChange: _propTypes2.default.func,
    panelTag: _propTypes2.default.string,
    tag: _propTypes2.default.string

    // UMD exports
};Tabbordion.Panel = Panel;
exports.default = Tabbordion;